CORESCHED(1)

BEZEICHNUNG
coresched - die wichtigsten Scheduling-Cookies für Tasks verwalten

ÜBERSICHT

coresched [get] [-s PID]

coresched new [-t Typ] -d PID

coresched new [-t Typ] -- Befehl [Argument …]

coresched copy [-s PID] [-t Typ] -d PID

coresched copy [-s PID] [-t Typ] -- Befehl [Argument …]

BESCHREIBUNG

Der Befehl coresched dient dazu, die Core-Scheduling-Cookies eines laufenden Prozesses anhand seiner PID abzurufen oder zu ändern oder einen neuen Befehl mit Core-Scheduling-Cookies zu erzeugen.

Das Core-Scheduling ermöglicht die Definition von Taskgruppen, die einen physischen Kern gemeinsam nutzen dürfen. Dies geschieht durch die Zuweisung eines Cookies zu jeder Task. Nur Tasks mit demselben Cookie dürfen auf demselben physischen Kern geplant werden.

Es ist möglich, einer Task entweder ein neues zufälliges Cookie zuzuweisen oder ein Cookie aus einer anderen Task zu kopieren. Der Wert des Cookies kann nicht ausgewählt werden.

FUNKTIONEN

get
    Ruft das Core-Scheduling-Cookie der in -s angegebenen PID ab. Wird -s weggelassen, wird das Cookie des aktuellen coresched-Prozesses abgerufen.

new
    Weist einer vorhandenen PID, die in -d angegeben ist, ein neues Cookie zu oder führt den angegebenen Befehl mit einem neuen Cookie aus.

copy
    Kopiert das Cookie von einer bestehenden PID (-s) in eine andere PID (-d) oder führt den angegebenen Befehl mit diesem Cookie aus. Wird -s weggelassen, wird das Cookie des aktuellen coresched-Prozesses abgerufen.

Wenn keine Funktion angegeben ist, wird die Funktion get ausgeführt.

OPTIONEN

-s, --source PID
    Gibt an, von welcher PID das Cookie abgerufen werden soll. Wird diese Option weggelassen, wird das Cookie vom aktuellen coresched-Prozess abgerufen.

-d, --dest PID
    Gibt die PID an, deren Cookie geändert werden soll.

-t, --dest-type TYP
    Der Typ der PID, deren Cookie geändert wird. Folgende drei Werte sind möglich:

        • PID oder Prozesskennung

        • tgid oder Thread-Gruppen-ID (Standardwert)

        • pgid oder Prozessgruppen-ID

-v, --verbose
    Zeigt zusätzliche Informationen an, wenn Cookies von Tasks geändert werden.

-h, --help
    zeigt einen Hilfetext an und beendet das Programm.

-V, --version
    zeigt Versionsinformationen an und beendet das Programm.

BEISPIELE

Das Core-Scheduling-Cookie der coresched-Task selbst abrufen, das normalerweise von seiner übergeordneten Task übernommen wird
    coresched get

    Das Core-Scheduling-Cookie einer Task mit PID 123 holen:
        coresched get -s 123

    Einer Aufgabe mit PID 123 ein neues Core-Scheduling-Cookie geben:
        coresched new -d 123

    Erstellen einer neuen Task mit einem neuen Core-Scheduling-Cookie:
        coresched new -- Befehl [Argument …]

    Das Cookie aus dem aktuellen coresched-Prozess in eine andere Task mit der PID 456 kopieren:
        coresched copy -d 456

    Das Cookie von einer Task mit der PID 123 in eine andere Task mit der PID 456 kopieren:
        coresched copy -s 123 -d 456

    Kopiert das Cookie von einer Aufgabe mit PID 123 in eine neue Task Befehl:
        coresched copy -s 123 -- Befehl [Argument …]

    Das Cookie von einer Task mit der PID 123 in die Prozessgruppen-ID 456 kopieren:
        coresched copy -s 123 -t pgid -d 456

ZUGRIFFSRECHTE

Das Abrufen oder Ändern des Core-Scheduling-Cookies eines Prozesses erfordert PTRACE_MODE_READ_REALCREDS Ptrace-Zugriff auf diesen Prozess. Weitere Informationen finden Sie im Abschnitt »Ptrace-Zugriffsmodusüberprüfung« in ptrace(2).

EXIT-STATUS

Bei Erfolg gibt coresched 0 zurück. Schlägt coresched fehl, wird ein Fehler ausgegeben und 1 zurückgegeben.

Wenn ein Befehl ausgeführt wird, ist der Rückgabewert von coresched der Rückgabewert von Befehl.

ANMERKUNGEN

coresched erfordert Core-Scheduling-Unterstützung im Kernel. Diese kann über die Kernel-Konfigurationsoption CONFIG_SCHED_CORE aktiviert werden.

AUTOREN

COPYRIGHT

Copyright © 2024 Thijs Raymakers und Phil Auld. Dies ist freie Software, lizenziert unter der EUPL.

SIEHE AUCH

chrt(1), nice(1), renice(1), taskset(1), ptrace(2), sched(7)

Die Linux-Kernel-Quelldateien Documentation/admin-guide/hw-vuln/core-scheduling.rst

FEHLER MELDEN

Nutzen Sie zum Melden von Fehlern das

VERFÜGBARKEIT

Der Befehl coresched ist Teil des Pakets util-linux, welches aus dem heruntergeladen werden kann.